scala.tools.nsc.backend.icode.ICodes

# icodeReader

###
Related Doc: package ICodes

#### object icodeReader extends ICodeReader

Source
  ICodes.scala

Linear Supertypes
ICodeReader, ClassfileParser, AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. icodeReader
2. ICodeReader
3. ClassfileParser
4. AnyRef
5. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class ConstantPool extends AnyRef

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Attributes
     protected
   Definition Classes
     ClassfileParser

2. #### class ICodeConstantPool extends ConstantPool

   Attributes
     protected
   Definition Classes
     ICodeReader

3. #### case class InnerClassEntry(external: Int, outer: Int, name: Int, jflags: JavaAccFlags) extends Product with Serializable

   An entry in the InnerClasses attribute of this class file.

   An entry in the InnerClasses attribute of this class file.

   Definition Classes
     ClassfileParser

4. #### class LazyAliasType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter

   Definition Classes
     ClassfileParser

5. #### class LinearCode extends AnyRef

   Definition Classes
     ICodeReader

6. #### type ThisConstantPool = ICodeConstantPool

   Attributes
     protected
   Definition Classes
     ICodeReader → ClassfileParser

7. #### class TypeParamsType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter

   Definition Classes
     ClassfileParser

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### val JVM: ClassfileConstants.type

   Definition Classes
     ICodeReader

5. #### def addEnclosingTParams(clazz: Global.Symbol): Unit

   Add type parameters of enclosing classes

   Add type parameters of enclosing classes

   Definition Classes
     ClassfileParser

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### var busy: Global.Symbol

   Attributes
     protected
   Definition Classes
     ClassfileParser

8. #### def classFileLookup: ClassFileLookup[AbstractFile]

   The way of the class file lookup used by the compiler.

   The way of the class file lookup used by the compiler.

   Definition Classes
     icodeReader → ClassfileParser

9. #### def classNameToSymbol(name: Global.Name): Global.Symbol

   Return the class symbol of the given name.

   Return the class symbol of the given name.

   Definition Classes
     ICodeReader → ClassfileParser

10. #### var classTParams: Map[Global.Name, Global.Symbol]

    Attributes
      protected
    Definition Classes
      ClassfileParser

11. #### var clazz: Global.Symbol

    Attributes
      protected
    Definition Classes
      ClassfileParser

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### var currentClass: Global.Name

    Attributes
      protected
    Definition Classes
      ClassfileParser

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

17. #### def forceMangledName(name: Global.Name, module: Boolean): Global.Symbol

    Try to force the chain of enclosing classes for the given name.

    Try to force the chain of enclosing classes for the given name. Otherwise flatten would not lift classes that were not referenced in the source code.

    Definition Classes
      ICodeReader

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def getCode(flags: JavaAccFlags): Global.icodes.IClass

    Return the icode class that should include members with the given flags.

    Return the icode class that should include members with the given flags. There are two possible classes, the static part and the instance part.

    Definition Classes
      ICodeReader

20. #### def getScope(flags: JavaAccFlags): Global.Scope

    Attributes
      protected
    Definition Classes
      ClassfileParser

21. #### lazy val global: ICodes.global.type

    Definition Classes
      icodeReader → ICodeReader

22. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

23. #### var in: AbstractFileReader

    Attributes
      protected
    Definition Classes
      ClassfileParser

24. #### object innerClasses

    Return the class symbol for the given name.

    Return the class symbol for the given name. It looks it up in its outer class. Forces all outer class symbols to be completed.

    If the given name is not an inner class, it returns the symbol found in `definitions`.

    Definition Classes
      ClassfileParser

25. #### var instanceCode: Global.icodes.IClass

    Definition Classes
      ICodeReader

26. #### var instanceScope: Global.Scope

    Attributes
      protected
    Definition Classes
      ClassfileParser

27. #### def isBox(m: Global.Symbol): Boolean

    Note: these methods are different from the methods of the same name found in Definitions.

    Note: these methods are different from the methods of the same name found in Definitions. These test whether a symbol represents one of the boxTo/unboxTo methods found in BoxesRunTime. The others test whether a symbol represents a synthetic method from one of the fake companion classes of the primitive types, such as Int.box(5).

    Definition Classes
      ICodeReader

28. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

29. #### var isScala: Boolean

    Attributes
      protected
    Definition Classes
      ClassfileParser

30. #### var isScalaAnnot: Boolean

    Attributes
      protected
    Definition Classes
      ClassfileParser

31. #### var isScalaModule: Boolean

    Definition Classes
      ICodeReader

32. #### var isScalaRaw: Boolean

    Attributes
      protected
    Definition Classes
      ClassfileParser

33. #### def isUnbox(m: Global.Symbol): Boolean

    Definition Classes
      ICodeReader

34. #### lazy val loaders: Global.loaders

    Definition Classes
      icodeReader → ICodeReader → ClassfileParser

35. #### def lookupMemberAtTyperPhaseIfPossible(sym: Global.Symbol, name: Global.Name): Global.Symbol

    If typer phase is defined then perform member lookup of a symbol `sym` at typer phase.

    If typer phase is defined then perform member lookup of a symbol `sym` at typer phase. This method results from refactoring. The original author of the logic that uses typer phase didn't explain why we need to force infos at that phase specifically. It only mentioned that ClassfileParse can be called late (e.g. at flatten phase) and we make to make sure we handle such situation properly.

    Definition Classes
      icodeReader → ClassfileParser

36. #### var maxLocals: Int

    Definition Classes
      ICodeReader

37. #### var maxStack: Int

    Definition Classes
      ICodeReader

38. #### var method: Global.icodes.IMethod

    Definition Classes
      ICodeReader

39. #### def moduleClass: Global.Symbol

    Attributes
      protected
    Definition Classes
      ClassfileParser

40. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

41. #### def newConstantPool: ICodeConstantPool

    Attributes
      protected
    Definition Classes
      ICodeReader → ClassfileParser

42. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

43. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

44. #### def parse(file: AbstractFile, root: Global.Symbol): Unit

    Definition Classes
      ClassfileParser

45. #### def parseAttribute(): Unit

    Definition Classes
      ICodeReader

46. #### def parseAttributes(sym: Global.Symbol, symtype: Global.Type): Unit

    Definition Classes
      ClassfileParser

47. #### def parseByteCode(): Unit

    Parse java bytecode into ICode

    Parse java bytecode into ICode

    Definition Classes
      ICodeReader

48. #### def parseClass(): Unit

    Definition Classes
      ICodeReader → ClassfileParser

49. #### def parseField(): Unit

    Definition Classes
      ICodeReader → ClassfileParser

50. #### def parseInnerClasses(): Unit

    Parse inner classes.

    Parse inner classes. Expects `in.bp` to point to the superclass entry. Restores the old `bp`.

    Definition Classes
      ClassfileParser

51. #### def parseMethod(): Unit

    Definition Classes
      ICodeReader → ClassfileParser

52. #### var pc: Int

    Definition Classes
      ICodeReader

53. #### var pool: ThisConstantPool

    Attributes
      protected
    Definition Classes
      ClassfileParser

54. #### def readClass(cls: Global.Symbol): (Global.icodes.IClass, Global.icodes.IClass)

    Read back bytecode for the given class symbol.

    Read back bytecode for the given class symbol. It returns two IClass objects, one for static members and one for non-static members.

    Definition Classes
      ICodeReader

55. #### def skipAttributes(): Unit

    Definition Classes
      ClassfileParser

56. #### def skipMembers(): Unit

    Definition Classes
      ClassfileParser

57. #### def skipSuperclasses(): Unit

    Definition Classes
      ClassfileParser

58. #### def srcfile: Option[AbstractFile]

    Definition Classes
      ClassfileParser

59. #### var srcfile0: Option[AbstractFile]

    Attributes
      protected
    Definition Classes
      ClassfileParser

60. #### var staticCode: Global.icodes.IClass

    Definition Classes
      ICodeReader

61. #### var staticModule: Global.Symbol

    Attributes
      protected
    Definition Classes
      ClassfileParser

62. #### var staticScope: Global.Scope

    Attributes
      protected
    Definition Classes
      ClassfileParser

63. #### lazy val symbolTable: global.type

    Definition Classes
      icodeReader → ICodeReader → ClassfileParser

64. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

65. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

66. #### def toUnsignedByte(b: Byte): Int

    Definition Classes
      ICodeReader

67. #### final def u1(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

68. #### final def u2(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

69. #### final def u4(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

70. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

71. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

72. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from ICodeReader

### Inherited from ClassfileParser

### Inherited from AnyRef

### Inherited from Any

### Ungrouped